from Components.HTMLComponent import HTMLComponent
from Components.GUIComponent import GUIComponent

from enigma import eSlider, eTimer

class ProgressWait(HTMLComponent, GUIComponent, object):
	def __init__(self):
		GUIComponent.__init__(self)
		self.__start = 0
		self.__end = 120
		self.__witdh = 20
		self.__cnt = 0
		self.__inc = 5

		self.timer = eTimer()
		self.timer.callback.append(self.timerEvent)
		print "[ProgressWait] initialized..."

	GUI_WIDGET = eSlider

	def postWidgetCreate(self, instance):
		instance.setRange(self.__start, self.__end)
		instance.setStartEnd(self.__cnt, self.__cnt + self.__witdh)

	def timerEvent(self):
		self.__cnt += self.__inc
		if self.__cnt > 99:
			self.__cnt = 100
			self.__inc = -self.__inc
		if self.__cnt < 1:
			self.__cnt = 0
			self.__inc = -self.__inc
		if self.instance is not None:
			self.instance.setStartEnd(self.__cnt, self.__cnt + self.__witdh)

	def onShow(self):
		self.__cnt = 0
		if self.__inc < 0:
			self.__inc = -self.__inc
		self.timer.start(100)
		print "[ProgressWait] Runtimer started..."

	def onHide(self):
		self.timer.stop()
		print "[ProgressWait] Runtimer stopped..."

	def preWidgetRemove(self, instance):
		print "[ProgressWait] finished..."

